/**
 * \file
 *
 * \brief Empty user application template
 *
 */

/**
 * \mainpage User Application template doxygen documentation
 *
 * \par Empty user application template
 *
 * Bare minimum empty user application template
 *
 * \par Content
 *
 * -# Include the ASF header files (through asf.h)
 * -# "Insert system clock initialization code here" comment
 * -# Minimal main function that starts with a call to board_init()
 * -# "Insert application code here" comment
 *
 */

/*
 * Include header files for all drivers that have been imported from
 * Atmel Software Framework (ASF).
 */
/*
 * Support and FAQ: visit <a href="http://www.atmel.com/design-support/">Atmel Support</a>
 */
#include <asf.h>

void FlashTest1(void){
	uint32_t uiValue = 0;
	uint32_t uiLength = sizeof(uiValue);
	uint32_t uiAddr =  (IFLASH_ADDR + IFLASH_SIZE - IFLASH_PAGE_SIZE * 4); //0x005ff800
	
	//flash_unlock(uiAddr, uiAddr+uiLength, 0, 0);	// Unlock memory to write
	flash_unlock(uiAddr, uiAddr+IFLASH_PAGE_SIZE, 0, 0);	// Unlock memory to write
	
	for(uint32_t i = 0; i < 32; i++){
		flash_write(uiAddr,&uiValue,uiLength,0);	// Write a data
		uiValue += 1;								// Increment the value
		uiAddr += sizeof(uiValue);//16;				// Increment address
	}
	
	//flash_lock(uiAddr, uiAddr+uiLength, 0, 0);	// Unlock memory to write
	flash_lock(uiAddr, uiAddr+IFLASH_PAGE_SIZE, 0, 0);		// Lock flash again
}

void FlashTest2(void){
	uint32_t uiData[] = {0x11221122,0x33443344,0x55665566,0x77887788};
	uint32_t uiMask[] = {0x01020102,0x03040304,0x05060506,0x07080708}; 
	uint32_t uiMask2[] = {0,0,0,0};
		
	uint32_t uiAddr = (IFLASH_ADDR + IFLASH_SIZE - IFLASH_PAGE_SIZE * 4); //0x005ff800
	uint32_t uiSize = sizeof(uiData);
	
	flash_unlock(uiAddr, uiAddr+IFLASH_PAGE_SIZE, 0, 0);	// Unlock memory to write
	flash_write(uiAddr,&uiData,uiSize,0);	//!-# Write a data
	flash_write(uiAddr,&uiMask,uiSize,0);	//!-# Does not like writing to the same spots...
	//flash_write(uiAddr,&uiMask,uiSize,0);	//!-# Does not like writing to the same spots...
	//flash_write(uiAddr,&uiMask2,uiSize,0);
	
	//!-# Continue writing on new address
	for(uint32_t i = 0; i < 50; i++){
		uiAddr += uiSize;
		flash_write(uiAddr,&uiData,uiSize,0);
	}
	flash_lock(uiAddr, uiAddr+IFLASH_PAGE_SIZE, 0, 0);	// Unlock memory to write
}

int main (void)
{
	/* Insert system clock initialization code here (sysclk_init()). */
	sysclk_init();
	board_init();
		
	flash_init(FLASH_ACCESS_MODE_128, 7);			// Initialize flash
	
	FlashTest1();
	//FlashTest2();
	
	while(1);										//Done
	/* Insert application code here, after the board has been initialized. */
}

